# coding: utf-8

"""
    VMware Aria Automation Assembler Blueprint API

    A multi-cloud Blueprint API for VMware Aria Automation Services  This page describes the RESTful APIs for Blueprint. The APIs facilitate CRUD operations on the various resources and entities used throughout Blueprint (Blueprints, Blueprint Terraform Integrations , PropertyGroups , etc.) and allow operations on them (creating a Blueprint, creating a Property group, etc.).  The APIs that list collections of resources  also support OData like implementation. Below query params can be used across Blueprint entities.  Example:  1. `$orderby` - returns a result with the rows being sorted by the values of provided attribute.      ```/blueprint/api/blueprints?$orderby=name%20desc```  2. `$top`, `$skip` - `$top` returns the requested number of resources. Used with `$skip`, the client can skip a given number of resources.      ```/blueprint/api/blueprints?$top=10&$skip=2```   # noqa: E501

    OpenAPI spec version: 2019-09-12
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class TerraformConfigurationSourceReference(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'source_directory': 'str',
        'repository_id': 'str',
        'commit_id': 'str'
    }

    attribute_map = {
        'source_directory': 'sourceDirectory',
        'repository_id': 'repositoryId',
        'commit_id': 'commitId'
    }

    def __init__(self, source_directory=None, repository_id=None, commit_id=None):  # noqa: E501
        """TerraformConfigurationSourceReference - a model defined in Swagger"""  # noqa: E501
        self._source_directory = None
        self._repository_id = None
        self._commit_id = None
        self.discriminator = None
        if source_directory is not None:
            self.source_directory = source_directory
        if repository_id is not None:
            self.repository_id = repository_id
        if commit_id is not None:
            self.commit_id = commit_id

    @property
    def source_directory(self):
        """Gets the source_directory of this TerraformConfigurationSourceReference.  # noqa: E501

        A path to the desired Terraform directory.  # noqa: E501

        :return: The source_directory of this TerraformConfigurationSourceReference.  # noqa: E501
        :rtype: str
        """
        return self._source_directory

    @source_directory.setter
    def source_directory(self, source_directory):
        """Sets the source_directory of this TerraformConfigurationSourceReference.

        A path to the desired Terraform directory.  # noqa: E501

        :param source_directory: The source_directory of this TerraformConfigurationSourceReference.  # noqa: E501
        :type: str
        """

        self._source_directory = source_directory

    @property
    def repository_id(self):
        """Gets the repository_id of this TerraformConfigurationSourceReference.  # noqa: E501

        The ID of the relevant configuration source repository.  # noqa: E501

        :return: The repository_id of this TerraformConfigurationSourceReference.  # noqa: E501
        :rtype: str
        """
        return self._repository_id

    @repository_id.setter
    def repository_id(self, repository_id):
        """Sets the repository_id of this TerraformConfigurationSourceReference.

        The ID of the relevant configuration source repository.  # noqa: E501

        :param repository_id: The repository_id of this TerraformConfigurationSourceReference.  # noqa: E501
        :type: str
        """

        self._repository_id = repository_id

    @property
    def commit_id(self):
        """Gets the commit_id of this TerraformConfigurationSourceReference.  # noqa: E501

        ID that identifies the commit that corresponds to the desired version of the remote file(s).  # noqa: E501

        :return: The commit_id of this TerraformConfigurationSourceReference.  # noqa: E501
        :rtype: str
        """
        return self._commit_id

    @commit_id.setter
    def commit_id(self, commit_id):
        """Sets the commit_id of this TerraformConfigurationSourceReference.

        ID that identifies the commit that corresponds to the desired version of the remote file(s).  # noqa: E501

        :param commit_id: The commit_id of this TerraformConfigurationSourceReference.  # noqa: E501
        :type: str
        """

        self._commit_id = commit_id

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(TerraformConfigurationSourceReference, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, TerraformConfigurationSourceReference):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
